Lua_ArtifactDetailsAttrItem = class("Lua_ArtifactDetailsAttrItem", Lua_DragContainerItem)
function Lua_ArtifactDetailsAttrItem:ctor(p)
	self:superCall("ctor", p, "ArtifactDetailsAttrItem_skin");
end

function Lua_ArtifactDetailsAttrItem:buildShowItem()
	self:superCall("buildShowItem");
	self._showHeight = 0;
end

function Lua_ArtifactDetailsAttrItem:dispose()
	if self.attrBgs then
		self.attrBgs:dispose();
		self.attrBgs:clear();
		self.attrBgs = nil;
	end
	if self.attrArr then
		self.attrArr:dispose();
		self.attrArr:clear();
		self.attrArr = nil;
	end
	self:superCall("dispose");
end

function Lua_ArtifactDetailsAttrItem:getWidth()
	return 650;
end

function Lua_ArtifactDetailsAttrItem:getHeight()
	return 54 + self._showHeight + 20;
end

function Lua_ArtifactDetailsAttrItem:setData(data)
	local arr = data:getBaseAttr();
	local dataLen = arr:getSize();

	local num = Mathf.Ceil(dataLen / 2);
	self._showHeight = num * 54;

	if self.attrBgs == nil then
		self.attrBgs = Array();
	end
	len = self.attrBgs:getSize();
	maxLen = num > len and num or len;
	local item;
	for i = 1, maxLen do
		item = self.attrBgs[i];
		if i > dataLen then
			if item then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = UICreate.createUIAtlasImage(self.content, "raccoon_atlas_2", "xui_bjbz_widget_2", 0, 0, 650, 44);
				item.anchorValue = 1;
				self.attrBgs:add(item);
			else
				item:setEnable(true);
			end
			item:setLocation(0, -88 + (i - 1) * -55, 0);
		end
	end

	if self.attrArr == nil then
		self.attrArr = Array();
	end
	len = self.attrArr:getSize();
	maxLen = dataLen > len and dataLen or len;
	local str;
	for i = 1, maxLen do
		item = self.attrArr[i];
		if i > dataLen then
			if item then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_AttrIconItem.new(self.content);
				item:setRectAnchor(1);
				item:setTextStyle(Lua_MyUISettings.defaultFontName, 24, "726763", 0, "FFFFFF")
				item.pivot = 1;
				item.spacingX = 10;
				self.attrArr:add(item);
			else
				item:setEnable(true);
			end
			item:setLocation(-220 + ((i - 1) % 2) * 300, -88 + Mathf.Floor((i - 1) / 2) * -55, 0);
			str = LanUtil.formateStr(350048, arr[i].show_name, arr[i].showValue);
			item:setData("common_altas_2", arr[i].attr_icon_2, str);
		end
	end
end