Lua_ArtifactDetailsSkillItem = class("Lua_ArtifactDetailsSkillItem", Lua_DragContainerItem)
function Lua_ArtifactDetailsSkillItem:ctor(p)
	self:superCall("ctor", p, "ArtifactDetailsSkillItem_skin");
end

function Lua_ArtifactDetailsSkillItem:buildShowItem()
	self:superCall("buildShowItem");

	self.skillItem = Lua_SkillIconItem.new(self.content);
	self.skillItem:setRectAnchor(1);
	self.skillItem:setLocation(-223.5, -146, 0);
end

function Lua_ArtifactDetailsSkillItem:dispose()
	if self.skillItem then
		self.skillItem:dispose();
		self.skillItem = nil;
	end
	if self.tagArr then
		self.tagArr:dispose();
		self.tagArr:clear();
		self.tagArr = nil;
	end
	if self.starArr then
		self.starArr:dispose();
		self.starArr:clear();
		self.starArr = nil;
	end
	self:superCall("dispose");
end

function Lua_ArtifactDetailsSkillItem:getWidth()
	return 650;
end

function Lua_ArtifactDetailsSkillItem:getHeight()
	return 54 + self.bg.height + 30;
end

function Lua_ArtifactDetailsSkillItem:setData(data)
	local addH = 100;
	local config = Lua_SkillConfigData.getConfigData(data.skill);
	self.skillItem:setData(config);
	self.nameText.text = config.name;
	self.nameText:resetSize();

	self:showTag(config.skill_tag);

	self.desText.text = config.des;
	self.desText:resetSize();
	addH = addH + self.desText.height;

	addH = addH + self:showStar(config, -150 + self.desText.height);

	self.bg:SetDimensions(650, addH);
end

function Lua_ArtifactDetailsSkillItem:showTag(list)
	if self.tagArr == nil then
		self.tagArr = Array();
	end
	local len = self.tagArr:getSize();
	local dataLen = list ~= nil and #list or 0;
	local maxLen = dataLen > len and dataLen or len;
	local item;
	local width;
	for i = 1, maxLen do
		item = self.tagArr[i];
		if i > dataLen then
			if item then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_ArtifactDetailsTagItem.new(self.content);
				item:setRectAnchor(1);
				self.tagArr:add(item);
			else
				item:setEnable(true);
			end
			width = item:setData(list[i]);
			width = self.nameText.posX + self.nameText.width + 50 + (i - 1) * (width + 10);
			item:setLocation(width, -120, 0);
		end
	end
end

function Lua_ArtifactDetailsSkillItem:showStar(config, posY)
	local arr = Array();
	if config.level > 1 then
		arr:add(config);
	end

	local data = config;
	while true do
		if data.prevId > 0 then
			data = Lua_SkillConfigData.getConfigData(data.prevId);
			if data.level > 1 then
				arr:add(data);
			end
		else
			break;
		end
	end

	data = config;
	while true do
		if data.nextId > 0 then
			data = Lua_SkillConfigData.getConfigData(data.nextId);
			if data.level > 1 then
				arr:add(data);
			end
		else
			break;
		end
	end

	local addH = 0;
	if self.starArr == nil then
		self.starArr = Array();
	end
	local item;
	local height;
	for i = 1, arr:getSize() do
		item = self.starArr[i];
		if item == nil then
			item = Lua_ArtifactDetailsStarItem.new(self.content);
			self.starArr:add(item);
		end
		height = item:setData(arr[i]);
		item:setLocation(0, posY - addH, 0);
		addH = addH + height + 5;
	end
	return addH;
end










Lua_ArtifactDetailsTagItem = class("Lua_ArtifactDetailsTagItem", Lua_DisplayObject)
function Lua_ArtifactDetailsTagItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ArtifactDetailsTagItem:buildShowItem()
	self:superCall("buildShowItem");

	self.bg = UICreate.createUIAtlasImage(self.content, "raccoon_atlas_2", "xui_bjbz_widget_10", 0, 0, 0, 0);

	self.tagText = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, 24);
	self.tagText.alignmentValue = 4;
	self.tagText.pivotValue = 4;
	self.tagText.horizontalOverflowValue = 1;
	self.tagText.fontName = Lua_MyUISettings.huakangFontName;
	self.tagText.colorStr = Lua_ColorDefine.transColor("E3D5C7");
end

function Lua_ArtifactDetailsTagItem:dispose()
	self:superCall("dispose");
end

function Lua_ArtifactDetailsTagItem:setData(data)
	self.tagText.text = data;
	self.tagText:resetSize();

	local width = self.tagText.width;
	self.bg:SetDimensions(width + 20, 33);
	return width;
end










Lua_ArtifactDetailsStarItem = class("Lua_ArtifactDetailsStarItem", Lua_DisplayObject)
function Lua_ArtifactDetailsStarItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ArtifactDetailsStarItem:buildShowItem()
	self:superCall("buildShowItem");
	self.starArr = Array();

	self.desText = UICreate.createLabel(self.content, nil, -131, 0, 435, 31, 22);
	self.desText.alignmentValue = 0;
	self.desText.pivotValue = 0;
	self.desText.horizontalOverflowValue = 0;
	self.desText.verticalOverflowValue = 1;
	self.desText.colorStr = Lua_ColorDefine.transColor("F88F13");
end

function Lua_ArtifactDetailsStarItem:dispose()
	if self.starArr then
		self.starArr:dispose();
		self.starArr:clear();
		self.starArr = nil;
	end
	self.desText = nil;
	self:superCall("dispose");
end

function Lua_ArtifactDetailsStarItem:setData(data)
	self:showStar(data.level);
	self.desText.text = data["des"..data.level];
	self.desText:resetSize();
	return self.desText.height;
end

function Lua_ArtifactDetailsStarItem:showStar(value)
	local len = self.starArr:getSize();
	value = value or 0;
	local maxLen = value > len and value or len;
	local star;
	for i = 1, maxLen do
		star = self.starArr[i];
		if i > value then
			if star then
				star:setEnable(false);
			end
		else
			if star == nil then
				star = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_label_05", 0, 0, 0, 0);
				star.anchorValue = 1;
				star.pivotValue = 1;
				self.starArr:add(star);
			else
				star:setEnable(true);
			end
		end
	end

	if value > 0  then
		local space = 20;
		local w = -(space * value) / 2 + space / 2;
		for i = 1, value do
			self.starArr[i]:setLocation(-223 + ((i - 1) % value) * space + w, 5, 0);
		end
	end
end