-- 神器详情
checkRequire("Lua_ArtifactDetailsAttrItem");
checkRequire("Lua_ArtifactDetailsSkillItem");
checkRequire("Lua_ArtifactDetailsTalentItem");
Lua_ArtifactDetailsWindow = class("Lua_ArtifactDetailsWindow", Lua_Window)
function Lua_ArtifactDetailsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ArtifactDetailsWindow";
	self.skinName = "ArtifactDetailsWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self:addPreLoadRes("common_altas_2", Lua_LoadFileType.ATLAS);
end

function Lua_ArtifactDetailsWindow:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("ARTIFACT_FORCE", self, self.onArtifactForce)

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(0, 353, 0);

	self.forceNum = Lua_NumberImage.new(self.content);
	self.forceNum.pivot = 1;
	self.forceNum.numOffsetX = -2;
	self.forceNum.numAtlas = "number";
	self.forceNum.preStr = "xui_zl1_number_0";

	self.dragContainer = Lua_DragContainer.new(self.content, 650, 600, Lua_AxisDefine.Vertical);
	self.dragContainer:setSiblingIndex(2);
	self.dragContainer:setLocation(0, -90, 0);
	self.dragContainer.callBackOwner = self;
	self.dragContainer.dragCallBack = self.updateSlider;

	self.arrowIcon:setEnable(false);
	self.btnPath:addClickFuntion(self, self.onCheckPath);
	self.btnGoto:addClickFuntion(self, self.onGoto);
end

function Lua_ArtifactDetailsWindow:dispose()
	if self.itemIcon then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.forceNum then
		self.forceNum:dispose();
		self.forceNum = nil;
	end
	if self.dragContainer then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	self:superCall("dispose");
end

function Lua_ArtifactDetailsWindow:showWin(param)
	self:superCall("showWin", param);
	Lua_ProxyManager.getProxy("Lua_ArtifactProxy"):sForce(param, 1, 0);
	self.data = DataCenter.artifactUtil:getArtifactVoById(param);
	self.titleName.text = self.data.name;

	self.itemIcon:setData(self.data);
	self.itemIcon:show_level(0);
	self.itemIcon:showStar(1);

	self.dragContainer:clearList();
	self.dragContainer:addSubContainer(Lua_ArtifactDetailsAttrItem, self.data);
	self.dragContainer:addSubContainer(Lua_ArtifactDetailsSkillItem, self.data);
	self.dragContainer:addSubContainer(Lua_ArtifactDetailsTalentItem, self.data);
	self.dragContainer:updateChildPos();

	local id = self.data.unlock_cond[1][1];
	local count = self.data.unlock_cond[1][2];
	local config = getConfig("item", id);
	self.chipIcon:setAltas(config.atlas, config.sprite);
	self.chipIcon:SetDimensions(112, 112);
	self.chipIcon:setScale(0.4, 0.4, 1);
	local haveCount = DataCenter.packData:getItemCountById(id);
	self.chipNum.text = LanUtil.formateStr(10044, tostring(haveCount), tostring(count));
end

function Lua_ArtifactDetailsWindow:updateSlider()
	self.arrowIcon:setEnable(not self.dragContainer.bDragEnd);
end

function Lua_ArtifactDetailsWindow:onArtifactForce(value)
	self.forceNum.num = value;
	local width = (self.forceIcon.width + self.forceNum.totalWidth + 10) / 2;
	self.forceIcon:setLocation(-width, 257, 0);
	self.forceNum:setLocation(-width + self.forceIcon.width + 10, 257, 0);
end

function Lua_ArtifactDetailsWindow:onCheckPath(go)
	if self.data == nil or self.data.unlock_cond == nil then
		return;
	end
	DataCenter.packUtil:openPathWindow(self.data.unlock_cond[1][1], false);
end

function Lua_ArtifactDetailsWindow:onGoto(go)
	if self.data == nil then
		return;
	end
	DataCenter.artifactUtil.curArtifact = self.data.id;
	DataCenter.funcPathUtil:gotoFunction(1053, true);
end